#pragma once

#include <Verso/Math/RgbaColorf.hpp>
#include <map>

namespace Verso {


enum class ColorRgb {
	Black = 0,
	Silver,
	Gray,
	White,
	Maroon,
	Red,
	Purple,
	Fuchsia,
	Green,
	Lime,
	Olive,
	Yellow,
	Navy,
	Blue,
	Teal,
	Aqua,

	AliceBlue,
	AntiqueWhite,
	AntiqueWhite2,
	AntiqueWhite3,
	AntiqueWhite4,
	AntiqueWhite5,
	Aquamarine,
	Aquamarine2,
	Aquamarine3,
	Azure,
	Beige,
	Bisque,
	BlanchedAlmond,
	BlenderBackground,
	BlenderGridPlaneGray,
	BlenderGridPlaneX,
	BlenderGridPlaneY,
	BlenderGridPlaneZ,
	BlenderFlatObject,
	BlenderHighlight,
	BlueViolet,
	Brown,
	BurlyWood,
	CadetBlue,
	Chartreuse,
	Chocolate,
	Coral,
	CornFlowerBlue,
	CornSilk,
	Crimson,
	Cyan,
	DarkBlue,
	DarkCyan,
	DarkGoldenRod,
	DarkGray,
	DarkGreen,
	DarkGrey,
	DarkKhaki,
	DarkMagenta,
	DarkOliveGreen,
	DarkOrange,
	DarkOrange2,
	DarkOrange3,
	DarkOrange4,
	DarkOrange5,
	DarkOrchid,
	DarkRed,
	DarkSalmon,
	DarkSeaGreen,
	DarkSeaGreen2,
	DarkSeaGreen3,
	DarkSeaGreen4,
	DarkSeaGreen5,
	DarkSlateBlue,
	DarkSlateGray,
	DarkSlateGrey,
	DarkTurquoise,
	DarkViolet,
	DeepPink,
	DeepPink2,
	DeepPink3,
	DeepPink4,
	DeepSkyBlue,
	DimGray,
	DimGrey,
	DodgerBlue,
	FireBrick,
	FloralWhite,
	ForestGreen,
	Gainsboro,
	GhostWhite,
	Gold,
	GoldenRod,
	GreenYellow,
	Grey,
	HoneyDew,
	HotPink,
	HotPink2,
	HotPink3,
	HotPink4,
	HotPink5,
	IndianRed,
	Indigo,
	Ivory,
	Khaki,
	Lavender,
	LavenderBlush,
	LawnGreen,
	LemonChiffon,
	LightBlue,
	LightCoral,
	LightCyan,
	LightGoldenRodYellow,
	LightGray,
	LightGreen,
	LightGrey,
	LightPink,
	LightSalmon,
	LightSeaGreen,
	LightSkyBlue,
	LightSlateGray,
	LightSlateGrey,
	LightSteelBlue,
	LightYellow,
	LimeGreen,
	Linen,
	Magenta,
	MediumAquamarine,
	MediumBlue,
	MediumOrchid,
	MediumPurple,
	MediumSeaGreen,
	MediumSlateBlue,
	MediumSpringGreen,
	MediumTurquoise,
	MediumVioletRed,
	MidnightBlue,
	MintCream,
	MistyRose,
	MistyRose2,
	MistyRose3,
	MistyRose4,
	Moccasin,
	NavajoWhite,
	NavajoWhite2,
	NavajoWhite3,
	NavajoWhite4,
	NiceOrange,
	NiceBackgroundGray,
	NiceBackgroundGray2,
	OldLace,
	OliveDrab,
	Orange,
	OrangeRed,
	OrangeRed2,
	OrangeRed3,
	OrangeRed4,
	Orchid,
	PaleGoldenRod,
	PaleGreen,
	PaleGreen2,
	PaleGreen3,
	PaleGreen4,
	PaleGreen5,
	PaleTurquoise,
	PaleTurquoise2,
	PaleTurquoise3,
	PaleTurquoise4,
	PaleTurquoise5,
	PaleVioletRed,
	PaleVioletRed2,
	PaleVioletRed3,
	PaleVioletRed4,
	PaleVioletRed5,
	PapayaWhip,
	PeachPuff,
	PeachPuff2,
	PeachPuff3,
	PeachPuff4,
	Peru,
	Pink,
	Plum,
	PowderBlue,
	RosyBrown,
	RoyalBlue,
	SaddleBrown,
	Salmon,
	SandyBrown,
	SeaGreen,
	SeaGreen2,
	SeaGreen3,
	SeaGreen4,
	SeaShell,
	Sienna,
	SkyBlue,
	SlateBlue,
	SlateGray,
	SlateGrey,
	Snow,
	SpringGreen,
	SteelBlue,
	Tan,
	Thistle,
	Tomato,
	Turquoise,
	Turquoise2,
	Turquoise3,
	Turquoise4,
	Turquoise5,
	Violet,
	Wheat,
	WhiteSmoke,
	YellowGreen,

	Last
};


class ColorGenerator
{
private:
	static std::vector<RgbaColorf> colors;
	static std::map<std::string, ColorRgb> stringToColor;
	static std::map<ColorRgb, std::string> colorToString;

public: // static
	VERSO_BASE_API static void setupColors();

	VERSO_BASE_API static RgbaColorf getColor(const ColorRgb& color);
};


} // End namespace Verso
